list(APPEND COMPILER_FLAGS /permissive-)
list(APPEND COMPILER_FLAGS -fno-delayed-template-parsing)

if (DEBUG_MODE)
  list(APPEND COMPILER_FLAGS /Od)
  list(APPEND COMPILER_FLAGS /Ob0)
  list(APPEND COMPILER_FLAGS /MDd)
  list(APPEND COMPILER_FLAGS /MP)
else()
  list(APPEND COMPILER_FLAGS /O2)
  list(APPEND COMPILER_FLAGS /Ob2)
  list(APPEND COMPILER_FLAGS /MD)
  list(APPEND COMPILER_FLAGS /MP)
endif()

set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT main)

set(GLEW_INC_DIR "${EXTERNAL_DIR}/glew/include/;")
set(GLEW_LIB_DIR "${EXTERNAL_DIR}/glew/lib/Release/x64/;")

set(BOOST_INC_DIR "${EXTERNAL_DIR}/boost/;")
set(BOOST_LIB_DIR "${EXTERNAL_DIR}/lib/;")

set(SOIL_INC_DIR "${EXTERNAL_DIR}/SOIL/;")
set(SOIL_LIB_DIR "${EXTERNAL_DIR}/SOIL/win64/Release/;")

set(SDL_INC_DIR "${EXTERNAL_DIR}/SDL/include/;")
set(SDL_LIB_DIR "${EXTERNAL_DIR}/SDL/lib/x64/;")

set(OPENAL_INC_DIR "${EXTERNAL_DIR}/openal/;")
set(OPENAL_LIB_DIR "${EXTERNAL_DIR}/openal/win64/Release/;")

set(WINDOWS_ONLY_INCLUDE_DIRECTORIES ${GLEW_INC_DIR} ${BOOST_INC_DIR} ${SOIL_INC_DIR} ${SDL_INC_DIR} ${OPENAL_INC_DIR})
set(WINDOWS_ONLY_LINKER_LIBRARIES ${GLEW_LIB_DIR} ${BOOST_LIB_DIR} ${SOIL_LIB_DIR} ${SDL_LIB_DIR} ${OPENAL_LIB_DIR})

set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} ${WINDOWS_ONLY_INCLUDE_DIRECTORIES})
set(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} ${WINDOWS_ONLY_LINKER_LIBRARIES})

###################################################################################################
# Preprocessor definitions
add_compile_definitions(OS_IS_WINDOWS=1)
add_compile_definitions(BOOST_STACKTRACE_USE_NOOP=1)
add_compile_definitions(NOMINMAX=1)
